diff -up dhcp-4.2.4-P1/common/parse.c.tzoff dhcp-4.2.4-P1/common/parse.c                                                                                                                                             
--- dhcp-4.2.4-P1/common/parse.c.tzoff  2012-07-13 08:18:05.000000000 +0200                                                                                                                                          
+++ dhcp-4.2.4-P1/common/parse.c        2012-08-27 14:08:15.968054179 +0200                                                                                                                                          
@@ -887,15 +887,12 @@ void convert_num (cfile, buf, str, base,                                                                                                                                                       
 /*                                                                                                                                                                                                                  
  * date :== NUMBER NUMBER SLASH NUMBER SLASH NUMBER                                                                                                                                                                 
  *             NUMBER COLON NUMBER COLON NUMBER |                                                                                                                                                                   
- *          NUMBER NUMBER SLASH NUMBER SLASH NUMBER                                                                                                                                                                 
- *             NUMBER COLON NUMBER COLON NUMBER NUMBER |                                                                                                                                                            
  *          EPOCH NUMBER |                                                                                                                                                                                          
  *         NEVER                                                                                                                                                                                                    
  *                                                                                                                                                                                                                  
- * Dates are stored in UTC or with a timezone offset; first number is day                                                                                                                                           
- * of week; next is year/month/day; next is hours:minutes:seconds on a                                                                                                                                              
- * 24-hour clock, followed by the timezone offset in seconds, which is                                                                                                                                              
- * optional.                                                                                                                                                                                                        
+ * Dates are stored as day-and-time in UTC or as seconds-since-epoch;                                                                                                                                               
+ * In first case the first number is day of week; next is year/month/day;                                                                                                                                           
+ * next is hours:minutes:seconds on a 24-hour clock.                                                                                                                                                                
  */                                                                                                                                                                                                                 

 /*                                                                                                                                                                                                                  
@@ -907,7 +904,7 @@ parse_date_core(cfile)                                                                                                                                                                           
        struct parse *cfile;                                                                                                                                                                                         
 {                                                                                                                                                                                                                   
        int guess;                                                                                                                                                                                                   
-       int tzoff, year, mon, mday, hour, min, sec;                                                                                                                                                                  
+       int year, mon, mday, hour, min, sec;
        const char *val;
        enum dhcp_token token;
        static int months[11] = { 31, 59, 90, 120, 151, 181,
@@ -1064,15 +1061,11 @@ parse_date_core(cfile)
        token = next_token(&val, NULL, cfile); /* consume second */
        sec = atoi(val);
 
-       tzoff = 0;
        token = peek_token(&val, NULL, cfile);
-       if (token == NUMBER) {
-               token = next_token(&val, NULL, cfile); /* consume tzoff */
-               tzoff = atoi(val);
-       } else if (token != SEMI) {
+       if (token != SEMI) {
                token = next_token(&val, NULL, cfile);
                parse_warn(cfile,
-                          "Time zone offset or semicolon expected.");
+                          "Semicolon expected.");
                return((TIME)0);
        }
 
@@ -1086,7 +1079,7 @@ parse_date_core(cfile)
                       !((year - 72) & 3)) +
                      mday - 1) * 24) +         /* Day of month */
                    hour) * 60) +
-                 min) * 60) + sec + tzoff;
+                 min) * 60) + sec;
 
        /* This guess could be wrong because of leap seconds or other
           weirdness we don't know about that the system does.   For